Index: sockit/avalon_arm_regs.vhdl
===================================================================
--- sockit/avalon_arm_regs.vhdl	(nonexistent)
+++ sockit/avalon_arm_regs.vhdl	(revision 311)
@@ -0,0 +1,330 @@
+---------------------------------------------------------------------------
+-- (c) 2014 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+LIBRARY ieee;
+USE ieee.std_logic_1164.all;
+use ieee.numeric_std.all;
+
+ENTITY avalon_arm_regs IS
+GENERIC
+(
+	platform : integer := 1 -- So ROM can detect which type of system...
+);
+PORT 
+( 
+	CLK : IN STD_LOGIC;
+	RESET_N : IN STD_LOGIC;
+	
+	POKEY_ENABLE : in std_logic;
+	
+	-- avalon signals
+	CHIPSELECT : IN STD_LOGIC;
+	ADDRESS : IN STD_LOGIC_VECTOR(10 downto 0);
+	READ: IN STD_LOGIC;
+	READDATA : OUT STD_LOGIC_VECTOR(31 downto 0);
+	WRITE : IN STD_LOGIC;
+	WRITEDATA : IN STD_LOGIC_VECTOR(31 downto 0);
+	BYTEENABLE : IN STD_LOGIC_VECTOR(3 downto 0);
+	
+	-- GENERIC INPUT REGS (need to synchronize upstream...)
+	IN1 : in std_logic_vector(31 downto 0); 
+	IN2 : in std_logic_vector(31 downto 0); 
+	IN3 : in std_logic_vector(31 downto 0); 
+	IN4 : in std_logic_vector(31 downto 0); 
+	
+	-- GENERIC OUTPUT REGS
+	OUT1 : out  std_logic_vector(31 downto 0); 
+	OUT2 : out  std_logic_vector(31 downto 0); 
+	OUT3 : out  std_logic_vector(31 downto 0); 
+	OUT4 : out  std_logic_vector(31 downto 0); 
+	OUT5 : out  std_logic_vector(31 downto 0); 
+	OUT6 : out  std_logic_vector(31 downto 0); 
+	
+	-- ATARI interface (in future we can also turbo load by directly hitting memory...)
+	SIO_DATA_IN  : out std_logic;
+	SIO_COMMAND : in std_logic;
+	SIO_DATA_OUT : in std_logic
+);
+END avalon_arm_regs;
+
+ARCHITECTURE vhdl OF avalon_arm_regs IS
+
+	function vectorize(s: std_logic) return std_logic_vector is
+	variable v: std_logic_vector(0 downto 0);
+	begin
+		v(0) := s;
+		return v;
+	end;
+	
+	signal device_decoded : std_logic_vector(7 downto 0);	
+	signal device_wr_en : std_logic_vector(7 downto 0);	
+	signal device_rd_en : std_logic_vector(7 downto 0);	
+	signal addr_decoded : std_logic_vector(15 downto 0);	
+	
+	signal out1_next : std_logic_vector(31 downto 0);
+	signal out1_reg : std_logic_vector(31 downto 0);
+	signal out2_next : std_logic_vector(31 downto 0);
+	signal out2_reg : std_logic_vector(31 downto 0);
+	signal out3_next : std_logic_vector(31 downto 0);
+	signal out3_reg : std_logic_vector(31 downto 0);
+	signal out4_next : std_logic_vector(31 downto 0);
+	signal out4_reg : std_logic_vector(31 downto 0);
+	signal out5_next : std_logic_vector(31 downto 0);
+	signal out5_reg : std_logic_vector(31 downto 0);
+	signal out6_next : std_logic_vector(31 downto 0);
+	signal out6_reg : std_logic_vector(31 downto 0);
+	
+	signal pokey_data_out : std_logic_vector(7 downto 0);
+	
+	signal subtimer_next : std_logic_vector(10 downto 0);
+	signal subtimer_reg : std_logic_vector(10 downto 0);
+
+	signal timer_next : std_logic_vector(31 downto 0);
+	signal timer_reg : std_logic_vector(31 downto 0);
+
+	signal data_out_regs : std_logic_vector(31 downto 0);
+	signal data_out_mux : std_logic_vector(31 downto 0);
+
+	signal read_sel : std_logic;
+	signal write_sel : std_logic;
+begin
+	-- register
+	process(clk,reset_n)
+	begin
+		if (reset_n='0') then
+			out1_reg <= (others=>'0');
+			out2_reg <= (others=>'0');
+			out3_reg <= (others=>'0');
+			out4_reg <= (others=>'0');
+			out5_reg <= (others=>'0');
+			out6_reg <= (others=>'0');
+			
+			subtimer_reg <= (others=>'0');
+			timer_reg <= (others=>'0');
+		elsif (clk'event and clk='1') then	
+			out1_reg <= out1_next;
+			out2_reg <= out2_next;
+			out3_reg <= out3_next;
+			out4_reg <= out4_next;
+			out5_reg <= out5_next;
+			out6_reg <= out6_next;
+			
+			subtimer_reg <= subtimer_next;
+			timer_reg <= timer_next;
+		end if;
+	end process;
+
+	-- decode address
+	decode_addr : entity work.complete_address_decoder
+		generic map(width=>4)
+		port map (addr_in=>address(3 downto 0), addr_decoded=>addr_decoded);
+
+	decode_device : entity work.complete_address_decoder
+		generic map(width=>3)
+		port map (addr_in=>address(10 downto 8), addr_decoded=>device_decoded);
+
+	-- device decode
+	-- 0x000 - own regs (0)
+	-- 0x100 - pokey (1)
+
+	write_sel <= write and chipselect;
+	read_sel <= read and chipselect;
+	device_wr_en <= device_decoded and (write_sel&write_sel&write_sel&write_sel&write_sel&write_sel&write_sel&write_sel);
+	device_rd_en <= device_decoded and (read_sel&read_sel&read_sel&read_sel&read_sel&read_sel&read_sel&read_sel);
+	
+	-- uart - another Pokey! Running at atari frequency.
+	-- with a state machine to capture command packets
+	-- can not easily poll frequently enough with zpu when also polling usb
+--	pokey1 : entity work.pokey
+--		port map (clk=>clk,ENABLE_179=>pokey_enable,addr=>addr(3 downto 0),data_in=>WRITEDATA(7 downto 0),wr_en=>device_wr_en(1), 
+--		reset_n=>reset_n,keyboard_response=>"11",pot_in=>X"00",
+--		sio_in1=>sio_data_out,sio_in2=>'1',sio_in3=>'1', -- TODO, pokey dir...
+--		data_out=>pokey_data_out, 
+--		sio_out1=>sio_data_in);
+
+pokey1 : entity work.sio_device
+PORT  MAP
+( 
+	CLK => CLK,
+	ADDR => address(4 downto 0),
+	CPU_DATA_IN => WRITEDATA(7 downto 0),
+	EN => device_rd_en(1),
+	WR_EN => device_wr_en(1),
+	
+	RESET_N => reset_n,
+
+	POKEY_ENABLE => pokey_enable,
+
+	SIO_DATA_IN  => sio_data_in,
+	SIO_COMMAND => sio_command,
+	SIO_DATA_OUT => sio_data_out,
+	
+	-- CPU interface
+	DATA_OUT => pokey_data_out
+);
+
+	-- timer for approx ms
+	process(timer_reg,subtimer_reg, pokey_enable)
+	begin
+		timer_next <= timer_reg;
+		subtimer_next <= subtimer_reg;
+
+		if (pokey_enable = '1') then
+			subtimer_next <= std_logic_vector(unsigned(subtimer_reg)-1);
+		end if;
+
+		if (subtimer_reg = "000"&x"00") then
+			subtimer_next <= std_logic_vector(to_unsigned(11#1790#,11));
+			timer_next <= std_logic_vector(unsigned(timer_reg)+1);
+		end if;
+
+	end process;
+
+	process(device_decoded, data_out_regs, pokey_data_out)
+	begin
+		data_out_mux <= (others=>'0');
+		if (device_decoded(0) = '1') then
+			data_out_mux <= data_out_regs;
+		end if;
+
+		if (device_decoded(1) = '1') then
+			data_out_mux(7 downto 0) <= pokey_data_out;
+		end if;
+
+	end process;
+
+	-- hardware regs for ZPU
+	--
+	-- 0-3: GENERIC INPUT (RO)
+	-- 4-7: GENERIC OUTPUT (R/W)
+	--  8: W:PAUSE, R:Timer (1ms)
+	--   9: SPI_DATA
+	-- SPI_DATA (DONE) 
+	--		W - write data (starts transmission)
+	--		R - read data (wait for complete first)
+	--  10: SPI_STATE
+	-- SPI_STATE/SPI_CTRL (DONE) 
+	--    R: 0=busy
+	--    W: 0=select_n, speed
+	--  11: SIO
+	-- SIO
+	--    R: 0=CMD
+	--  12: TYPE
+	-- FPGA board (DONE) 
+	--    R(32 bits) 0=DE1
+	--  13 : SPI_DMA
+	--    W(15 downto 0 = addr),(31 downto 16 = endAddr)
+	--  14-15 : GENERIC OUTPUT (R/W)
+	--  16-31: POKEY! Low bytes only... i.e. pokey reg every 4 bytes...
+				
+	-- Writes to registers
+	process(WRITEDATA,device_wr_en,address,addr_decoded, out1_reg, out2_reg, out3_reg, out4_reg, out5_reg, out6_reg, pokey_enable)
+	begin
+		out1_next <= out1_reg;
+		out2_next <= out2_reg;
+		out3_next <= out3_reg;
+		out4_next <= out4_reg;
+		out5_next <= out5_reg;
+		out6_next <= out6_reg;
+
+		if (device_wr_en(0) = '1') then
+			if(addr_decoded(4) = '1') then
+				out1_next <= WRITEDATA;
+			end if;	
+			
+			if(addr_decoded(5) = '1') then
+				out2_next <= WRITEDATA;
+			end if;	
+
+			if(addr_decoded(6) = '1') then
+				out3_next <= WRITEDATA;
+			end if;	
+
+			if(addr_decoded(7) = '1') then
+				out4_next <= WRITEDATA;
+			end if;	
+
+			if(addr_decoded(14) = '1') then
+				out5_next <= WRITEDATA;
+			end if;	
+
+			if(addr_decoded(15) = '1') then
+				out6_next <= WRITEDATA;
+			end if;	
+		end if;
+	end process;
+	
+	-- Read from registers
+	process(address,addr_decoded, in1, in2, in3, in4, out1_reg, out2_reg, out3_reg, out4_reg, out5_reg, out6_reg, SIO_COMMAND, timer_reg)
+	begin
+		data_out_regs <= (others=>'0');
+
+		if (addr_decoded(0) = '1') then
+			data_out_regs <= in1;
+		end if;
+		
+		if (addr_decoded(1) = '1') then
+			data_out_regs <= in2;
+		end if;		
+		
+		if (addr_decoded(2) = '1') then
+			data_out_regs <= in3;
+		end if;		
+		
+		if (addr_decoded(3) = '1') then
+			data_out_regs <= in4;
+		end if;
+
+		if (addr_decoded(4) = '1') then
+			data_out_regs <= out1_reg;
+		end if;
+		
+		if (addr_decoded(5) = '1') then
+			data_out_regs <= out2_reg;
+		end if;		
+		
+		if (addr_decoded(6) = '1') then
+			data_out_regs <= out3_reg;
+		end if;		
+		
+		if (addr_decoded(7) = '1') then
+			data_out_regs <= out4_reg;
+		end if;
+
+		if (addr_decoded(14) = '1') then
+			data_out_regs <= out5_reg;
+		end if;
+
+		if (addr_decoded(15) = '1') then
+			data_out_regs <= out6_reg;
+		end if;
+
+		if (addr_decoded(8) = '1') then
+			data_out_regs <= timer_reg;
+		end if;
+
+		if(addr_decoded(11) = '1') then
+			data_out_regs(0) <= SIO_COMMAND;
+		end if;	
+		
+		if (addr_decoded(12) = '1') then
+			data_out_regs <= std_logic_vector(to_unsigned(platform,32));
+		end if;
+	end process;	
+	
+	-- outputs
+	out1 <= out1_reg;
+	out2 <= out2_reg;
+	out3 <= out3_reg;
+	out4 <= out4_reg;
+	out5 <= out5_reg;
+	out6 <= out6_reg;
+	
+	READDATA <= data_out_mux;
+end vhdl;
+
+
Index: sockit/avalon_atari_dma.vhd
===================================================================
--- sockit/avalon_atari_dma.vhd	(nonexistent)
+++ sockit/avalon_atari_dma.vhd	(revision 311)
@@ -0,0 +1,82 @@
+---------------------------------------------------------------------------
+-- (c) 2014 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+LIBRARY ieee;
+USE ieee.std_logic_1164.all;
+USE ieee.std_logic_misc.all;
+
+ENTITY avalon_atari_dma IS
+PORT 
+( 
+	CLK : IN STD_LOGIC;
+	RESET_N : IN STD_LOGIC;
+	
+	-- avalon signals
+	CHIPSELECT : IN STD_LOGIC;
+	ADDRESS : IN STD_LOGIC_VECTOR(21 downto 0);
+	READ: IN STD_LOGIC;
+	READDATA : OUT STD_LOGIC_VECTOR(31 downto 0);
+	WRITE : IN STD_LOGIC;
+	WRITEDATA : IN STD_LOGIC_VECTOR(31 downto 0);
+	BYTEENABLE : IN STD_LOGIC_VECTOR(3 downto 0);
+	WAITREQUEST : OUT STD_LOGIC;
+	
+	-- atari dma signals
+	DMA_FETCH : OUT STD_LOGIC;
+	DMA_READ_ENABLE : OUT STD_LOGIC;
+	DMA_32BIT_WRITE_ENABLE : OUT STD_LOGIC; -- cough, width for read or writes...
+	DMA_8BIT_WRITE_ENABLE : OUT STD_LOGIC;
+	DMA_ADDR : OUT STD_LOGIC_VECTOR(23 downto 0);
+	DMA_WRITE_DATA : OUT STD_LOGIC_VECTOR(31 downto 0);
+	MEMORY_READY_DMA : IN STD_LOGIC;
+	DMA_MEMORY_DATA : IN STD_LOGIC_VECTOR(31 downto 0)
+);
+END avalon_atari_dma;
+
+ARCHITECTURE vhdl OF avalon_atari_dma IS
+	SIGNAL BYTE_ADDRESS : STD_LOGIC_VECTOR(1 downto 0);
+BEGIN
+	DMA_FETCH <= (READ or WRITE) and CHIPSELECT;
+	DMA_READ_ENABLE <= READ;
+	DMA_ADDR <= ADDRESS&BYTE_ADDRESS;
+	WAITREQUEST <= NOT(MEMORY_READY_DMA) or not(RESET_N);
+
+	process(BYTEENABLE, DMA_MEMORY_DATA, WRITEDATA)
+	begin
+		BYTE_ADDRESS <= "00";
+		DMA_8BIT_WRITE_ENABLE <= '0';
+		DMA_32BIT_WRITE_ENABLE <= '0';
+		READDATA <= DMA_MEMORY_DATA;
+		DMA_WRITE_DATA <= WRITEDATA;
+
+		case BYTEENABLE is
+		when "0001" =>
+			DMA_8BIT_WRITE_ENABLE <= '1';
+			READDATA <= DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0);
+			DMA_WRITE_DATA <= x"000000"&WRITEDATA(7 downto 0);
+		when "0010" =>
+			BYTE_ADDRESS <= "01";
+			DMA_8BIT_WRITE_ENABLE <= '1';
+			READDATA <= DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0);
+			DMA_WRITE_DATA <= x"000000"&WRITEDATA(15 downto 8);
+		when "0100" =>
+			BYTE_ADDRESS <= "10";
+			DMA_8BIT_WRITE_ENABLE <= '1';
+			READDATA <= DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0);
+			DMA_WRITE_DATA <= x"000000"&WRITEDATA(23 downto 16);
+		when "1000" =>
+			BYTE_ADDRESS <= "11";
+			DMA_8BIT_WRITE_ENABLE <= '1';
+			READDATA <= DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0)&DMA_MEMORY_DATA(7 downto 0);
+			DMA_WRITE_DATA <= x"000000"&WRITEDATA(31 downto 24);
+		when "1111" =>
+			DMA_32BIT_WRITE_ENABLE <= '1';
+		when others =>
+			-- invalid
+		end case;
+	end process;
+END vhdl;
Index: sockit/build.sh
===================================================================
--- sockit/build.sh	(revision 310)
+++ sockit/build.sh	(revision 311)
@@ -4,9 +4,13 @@
 cp altiobuf.* build
 cp altiobufo.* build
 cp pll_pal.* build
+cp avalon_a* build
 cp -r pll_pal build
 cp -r pll_pal_sim build
 cp atari800core.sdc build
+cp atari800core.qpf build
+cp atari_hps.qsys build
+cp i2* build
 
 mkdir build/common
 mkdir build/common/a8core
@@ -19,4 +23,5 @@
 cd build
 ../makeqsf ../atari800core.qsf ./common/a8core ./common/components ./common/zpu
 
-quartus_sh --flow compile atari800core
+ip-generate atari_hps.qsys --file-set=QUARTUS_SYNTH --standard-reports > qsys.log 2> qsys.err
+quartus_sh --flow compile atari800core > build.log 2> build.err
Index: sockit/i2c_loader.vhd
===================================================================
--- sockit/i2c_loader.vhd	(nonexistent)
+++ sockit/i2c_loader.vhd	(revision 311)
@@ -0,0 +1,302 @@
+-- ZX Spectrum for Altera DE1
+--
+-- Copyright (c) 2009-2010 Mike Stirling
+--
+-- All rights reserved
+--
+-- Redistribution and use in source and synthezised forms, with or without
+-- modification, are permitted provided that the following conditions are met:
+--
+-- * Redistributions of source code must retain the above copyright notice,
+--   this list of conditions and the following disclaimer.
+--
+-- * Redistributions in synthesized form must reproduce the above copyright
+--   notice, this list of conditions and the following disclaimer in the
+--   documentation and/or other materials provided with the distribution.
+--
+-- * Neither the name of the author nor the names of other contributors may
+--   be used to endorse or promote products derived from this software without
+--   specific prior written permission.
+--
+-- THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
+-- AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO,
+-- THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+-- PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE
+-- LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+-- CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+-- SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+-- INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+-- CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+-- ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+-- POSSIBILITY OF SUCH DAMAGE.
+--
+
+library IEEE;
+use IEEE.STD_LOGIC_1164.ALL;
+use IEEE.STD_LOGIC_ARITH.ALL;
+use IEEE.STD_LOGIC_UNSIGNED.ALL;
+use IEEE.STD_LOGIC_MISC.ALL; -- for AND_REDUCE
+use IEEE.NUMERIC_STD.ALL;
+
+entity i2c_loader is
+generic (
+	-- Address of slave to be loaded
+	device_address : integer := 16#1a#;
+	-- Number of retries to allow before stopping
+	num_retries : integer := 0;
+	-- Length of clock divider in bits.  Resulting bus frequency is
+	-- CLK/2^(log2_divider + 2)
+	log2_divider : integer := 7
+);
+
+port (
+	CLK			:	in	std_logic;
+	nRESET		:	in	std_logic;
+	
+	I2C_SCL		:	inout	std_logic;
+	I2C_SDA		:	inout	std_logic;
+	
+	IS_DONE		:	out std_logic;
+	IS_ERROR	:	out	std_logic
+	);
+end i2c_loader;
+
+architecture i2c_loader_arch of i2c_loader is
+type regs is array(0 to 19) of std_logic_vector(7 downto 0);
+constant init_regs : regs := (
+	-- Left line in, 0dB, mute
+	X"00", X"97",
+	-- Right line in, 0dB, mute
+	X"02", X"97",
+	-- Left headphone out, -29dB, zero cross disabled
+	--X"04", X"58",
+	X"04", X"68",
+	-- Right headphone out, -29dB, zero cross disabled
+	--X"06", X"58",
+	X"06", X"68",
+	-- Audio path, DAC enabled, Line in, Bypass off, mic muted
+	X"08", X"12",
+	-- Digital path, Unmute, HP filter enabled
+	X"0A", X"00",
+	-- Power down mic, clkout and xtal osc, line in and adc
+	X"0C", X"67",
+	-- Format 16-bit I2S, no bit inversion or phase changes, MASTER
+	X"0E", X"42",
+	-- Sampling control, Normal mode, mclk/2 used, We should provide 12.288MHz but will provide 12.25MHz - making 96KHz notional, 97.656KHz actual 
+	X"10", X"DC",
+	-- Activate
+	X"12", X"01"
+	);
+-- Number of bursts (i.e. total number of registers)
+constant burst_length : positive := 2;
+-- Number of bytes to transfer per burst
+constant num_bursts : positive := (init_regs'length / burst_length);
+	
+type state_t is (Idle, Start, Data, Ack, Stop, Pause, Done);
+signal state : state_t;
+signal phase : std_logic_vector(1 downto 0);
+subtype nbit_t is integer range 0 to 7;
+signal nbit : nbit_t;
+subtype nbyte_t is integer range 0 to burst_length; -- +1 for address byte
+signal nbyte : nbyte_t;
+subtype thisbyte_t is integer range 0 to init_regs'length; -- +1 for "done"
+signal thisbyte : thisbyte_t;
+subtype retries_t is integer range 0 to num_retries;
+signal retries : retries_t;
+
+signal clken : std_logic;
+signal divider : std_logic_vector(log2_divider-1 downto 0);
+signal shiftreg : std_logic_vector(7 downto 0);
+signal scl_out : std_logic;
+signal sda_out : std_logic;
+signal nak : std_logic;
+begin
+	-- Create open-drain outputs for I2C bus
+	I2C_SCL <= '0' when scl_out = '0' else 'Z';
+	I2C_SDA <= '0' when sda_out = '0' else 'Z';
+	-- Status outputs are driven both ways
+	IS_DONE <= '1' when state = Done else '0';
+	IS_ERROR <= nak;
+	
+	-- Generate clock enable for desired bus speed
+	clken <= AND_REDUCE(divider);
+	process(nRESET,CLK)
+	begin
+		if nRESET = '0' then
+			divider <= (others => '0');
+		elsif falling_edge(CLK) then
+			divider <= divider + '1';
+		end if;
+	end process;
+
+	-- The I2C loader process
+	process(nRESET,CLK,clken)
+	begin
+		if nRESET = '0' then
+			scl_out <= '1';
+			sda_out <= '1';
+			state <= Idle;
+			phase <= "00";
+			nbit <= 0;
+			nbyte <= 0;
+			thisbyte <= 0;
+			shiftreg <= (others => '0');
+			nak <= '0'; -- No error
+			retries <= num_retries;
+		elsif rising_edge(CLK) and clken = '1' then
+  			-- Next phase by default
+			phase <= phase + 1;
+
+			-- STATE: IDLE
+			if state = Idle then
+				-- Start loading the device registers straight away
+				-- A 'GO' bit could be polled here if required
+				state <= Start;
+				phase <= "00";
+				scl_out <= '1';
+				sda_out <= '1';
+				
+			-- STATE: START
+			elsif state = Start then
+				-- Generate START condition
+				case phase is
+				when "00" =>
+					-- Drop SDA first
+					sda_out <= '0';
+				when "10" =>
+					-- Then drop SCL
+					scl_out <= '0';
+				when "11" =>
+					-- Advance to next state
+					-- Shift register loaded with device slave address
+					state <= Data;
+					nbit <= 7;
+					shiftreg <= std_logic_vector(to_unsigned(device_address,7)) & '0'; -- writing
+					nbyte <= burst_length;
+				when others =>
+					null;
+				end case;
+				
+			-- STATE: DATA
+			elsif state = Data then
+				-- Generate data
+				case phase is
+				when "00" =>
+					-- Drop SCL
+					scl_out <= '0';
+				when "01" =>
+					-- Output data and shift (MSb first)
+					sda_out <= shiftreg(7);
+					shiftreg <= shiftreg(6 downto 0) & '0';
+				when "10" =>
+					-- Raise SCL
+					scl_out <= '1';
+				when "11" =>
+					-- Next bit or advance to next state when done
+					if nbit = 0 then
+						state <= Ack;
+					else
+						nbit <= nbit - 1;
+					end if;
+				when others =>
+				  null;
+				end case;
+				
+			-- STATE: ACK
+			elsif state = Ack then
+				-- Generate ACK clock and check for error condition
+				case phase is
+				when "00" =>
+					-- Drop SCL
+					scl_out <= '0';
+				when "01" =>
+					-- Float data
+					sda_out <= '1';
+				when "10" =>
+					-- Sample ack bit
+					nak <= I2C_SDA;
+					if I2C_SDA = '1' then
+						-- Error
+						nbyte <= 0; -- Close this burst and skip remaining registers
+						thisbyte <= init_regs'length;
+					else
+						-- Hold ACK to avoid spurious stops - this seems to fix a
+						-- problem with the Wolfson codec which releases the ACK
+						-- right on the falling edge of the clock pulse.  It looks like
+						-- the device interprets this is a STOP condition and then fails
+						-- to acknowledge the next byte.  We can avoid this by holding the
+						-- ACK condition for a little longer.
+						sda_out <= '0';
+					end if;
+					-- Raise SCL
+					scl_out <= '1';
+				when "11" =>
+					-- Advance to next state
+					if nbyte = 0 then
+						-- No more bytes in this burst - generate a STOP
+						state <= Stop;
+					else
+						-- Generate next byte
+						state <= Data;
+						nbit <= 7;
+						shiftreg <= init_regs(thisbyte);
+						nbyte <= nbyte - 1;
+						thisbyte <= thisbyte + 1;
+					end if;
+				when others =>
+					null;
+				end case;
+				
+			-- STATE: STOP
+			elsif state = Stop then
+				-- Generate STOP condition
+				case phase is
+				when "00" =>
+					-- Drop SCL first
+					scl_out <= '0';
+				when "01" =>
+					-- Drop SDA
+					sda_out <= '0';
+				when "10" =>
+					-- Raise SCL
+					scl_out <= '1';
+				when "11" =>
+					if thisbyte = init_regs'length then
+						-- All registers done, advance to finished state.  This will
+						-- bring SDA high while SCL is still high, completing the STOP
+						-- condition
+						state <= Done;
+					else
+						-- Load the next register after a short delay
+						state <= Pause;
+					end if;
+				when others =>
+					null;
+				end case;
+				
+			-- STATE: PAUSE
+			elsif state = Pause then
+				-- Delay for one cycle of 'phase' then start the next burst
+				scl_out <= '1';
+				sda_out <= '1';
+				if phase = "11" then
+					state <= Start;
+				end if;
+				
+			-- STATE: DONE
+			else
+				-- Finished
+				scl_out <= '1';
+				sda_out <= '1';
+				
+				if nak = '1' and retries > 0 then
+					-- We can retry in the event of a NAK in case the
+					-- slave got out of sync for some reason
+					retries <= retries - 1;
+					state <= Idle;
+				end if;
+			end if;
+		end if;
+	end process;
+end i2c_loader_arch;
+
Index: sockit/i2sslave.vhdl
===================================================================
--- sockit/i2sslave.vhdl	(nonexistent)
+++ sockit/i2sslave.vhdl	(revision 311)
@@ -0,0 +1,77 @@
+---------------------------------------------------------------------------
+-- (c) 2013 mark watson
+-- I am happy for anyone to use this for non-commercial use.
+-- If my vhdl files are used commercially or otherwise sold,
+-- please contact me for explicit permission at scrameta (gmail).
+-- This applies for source and binary form and derived works.
+---------------------------------------------------------------------------
+LIBRARY ieee;
+USE ieee.std_logic_1164.all;
+
+ENTITY i2sslave IS
+PORT 
+( 
+	CLK_HALF : IN STD_LOGIC;
+	
+	BCLK : IN STD_LOGIC;
+	DACLRC : IN STD_LOGIC;
+	
+	LEFT_IN : in std_logic_vector(15 downto 0);
+	RIGHT_IN : in std_logic_vector(15 downto 0);
+	
+	MCLK_2 : OUT STD_LOGIC;
+	DACDAT : OUT STD_LOGIC
+);
+END i2sslave;
+
+ARCHITECTURE vhdl OF i2sslave IS
+	signal bclk_reg : std_logic;
+	signal bclk_last_reg : std_logic;
+	signal daclrc_reg : std_logic;
+	signal daclrc_last_reg : std_logic;
+	
+	signal shiftreg_reg : std_logic_vector(15 downto 0);
+	signal shiftreg_next : std_logic_vector(15 downto 0);
+BEGIN
+	MCLK_2 <= CLK_HALF; -- bad practice, but pll out of...
+	
+	-- Data read on bclk low->high transition
+	-- daclrc is set on bclk high->low transition
+	
+	-- register inputs
+	process(CLK_HALF)
+	begin	
+		if (CLK_HALF'event and CLK_HALF='1') then
+			bclk_reg <= bclk;
+			bclk_last_reg <= bclk_reg;
+			daclrc_reg <= daclrc;
+			daclrc_last_reg <= daclrc_reg;
+			shiftreg_reg <= shiftreg_next;
+		end if;
+	end process;
+	
+	-- sample on change to daclrc, shift out bit if required
+	process(daclrc_reg,daclrc_last_reg,bclk_reg,shiftreg_reg,left_in,right_in,bclk_last_reg)
+		variable reload : std_logic;
+	begin
+		reload := '0';
+		shiftreg_next <= shiftreg_reg;
+		
+		if (daclrc_reg = '1' and daclrc_last_reg = '0') then
+			shiftreg_next <= right_in;
+			reload := '1';
+		end if;
+		
+		if (daclrc_reg = '0' and daclrc_last_reg = '1') then
+			shiftreg_next <= left_in;
+			reload := '1';
+		end if;
+		
+		if (bclk_reg = '0' and bclk_last_reg = '1' and reload='0') then
+				shiftreg_next <= shiftreg_reg(14 downto 0)&'0';
+		end if;
+			
+	end process;
+	
+	DACDAT <= shiftreg_reg(15);
+END vhdl;
\ No newline at end of file
Index: sockit/pll_pal/pll_pal_0002.v
===================================================================
--- sockit/pll_pal/pll_pal_0002.v	(revision 310)
+++ sockit/pll_pal/pll_pal_0002.v	(revision 311)
@@ -10,6 +10,9 @@
 	// interface 'outclk0'
 	output wire outclk_0,
 
+	// interface 'outclk1'
+	output wire outclk_1,
+
 	// interface 'locked'
 	output wire locked
 );
@@ -18,11 +21,11 @@
 		.fractional_vco_multiplier("false"),
 		.reference_clock_frequency("50.0 MHz"),
 		.operation_mode("normal"),
-		.number_of_clocks(1),
+		.number_of_clocks(2),
 		.output_clock_frequency0("56.750000 MHz"),
 		.phase_shift0("0 ps"),
 		.duty_cycle0(50),
-		.output_clock_frequency1("0 MHz"),
+		.output_clock_frequency1("28.375000 MHz"),
 		.phase_shift1("0 ps"),
 		.duty_cycle1(50),
 		.output_clock_frequency2("0 MHz"),
@@ -77,7 +80,7 @@
 		.pll_subtype("General")
 	) altera_pll_i (
 		.rst	(rst),
-		.outclk	({outclk_0}),
+		.outclk	({outclk_1, outclk_0}),
 		.locked	(locked),
 		.fboutclk	( ),
 		.fbclk	(1'b0),
Index: sockit/pll_pal.bsf
===================================================================
--- sockit/pll_pal.bsf	(revision 310)
+++ sockit/pll_pal.bsf	(revision 311)
@@ -21,9 +21,9 @@
 */
 (header "symbol" (version "1.1"))
 (symbol
-	(rect 0 0 160 144)
+	(rect 0 0 160 184)
 	(text "pll_pal" (rect 62 -1 85 11)(font "Arial" (font_size 10)))
-	(text "inst" (rect 8 128 20 140)(font "Arial" ))
+	(text "inst" (rect 8 168 20 180)(font "Arial" ))
 	(port
 		(pt 0 72)
 		(input)
@@ -48,10 +48,17 @@
 	(port
 		(pt 160 112)
 		(output)
-		(text "locked" (rect 0 0 24 12)(font "Arial" (font_size 8)))
-		(text "locked" (rect 127 101 163 112)(font "Arial" (font_size 8)))
+		(text "outclk_1" (rect 0 0 31 12)(font "Arial" (font_size 8)))
+		(text "outclk_1" (rect 119 101 167 112)(font "Arial" (font_size 8)))
 		(line (pt 160 112)(pt 112 112)(line_width 1))
 	)
+	(port
+		(pt 160 152)
+		(output)
+		(text "locked" (rect 0 0 24 12)(font "Arial" (font_size 8)))
+		(text "locked" (rect 127 141 163 152)(font "Arial" (font_size 8)))
+		(line (pt 160 152)(pt 112 152)(line_width 1))
+	)
 	(drawing
 		(text "refclk" (rect 16 43 68 99)(font "Arial" (color 128 0 0)(font_size 9)))
 		(text "clk" (rect 53 67 124 144)(font "Arial" (color 0 0 0)))
@@ -59,13 +66,15 @@
 		(text "reset" (rect 53 107 136 224)(font "Arial" (color 0 0 0)))
 		(text "outclk0" (rect 113 43 268 99)(font "Arial" (color 128 0 0)(font_size 9)))
 		(text "clk" (rect 97 67 212 144)(font "Arial" (color 0 0 0)))
-		(text "locked" (rect 113 83 262 179)(font "Arial" (color 128 0 0)(font_size 9)))
-		(text "export" (rect 82 107 200 224)(font "Arial" (color 0 0 0)))
-		(text " altera_pll " (rect 118 128 308 266)(font "Arial" ))
+		(text "outclk1" (rect 113 83 268 179)(font "Arial" (color 128 0 0)(font_size 9)))
+		(text "clk" (rect 97 107 212 224)(font "Arial" (color 0 0 0)))
+		(text "locked" (rect 113 123 262 259)(font "Arial" (color 128 0 0)(font_size 9)))
+		(text "export" (rect 82 147 200 304)(font "Arial" (color 0 0 0)))
+		(text " altera_pll " (rect 118 168 308 346)(font "Arial" ))
 		(line (pt 48 32)(pt 112 32)(line_width 1))
-		(line (pt 112 32)(pt 112 128)(line_width 1))
-		(line (pt 48 128)(pt 112 128)(line_width 1))
-		(line (pt 48 32)(pt 48 128)(line_width 1))
+		(line (pt 112 32)(pt 112 168)(line_width 1))
+		(line (pt 48 168)(pt 112 168)(line_width 1))
+		(line (pt 48 32)(pt 48 168)(line_width 1))
 		(line (pt 49 52)(pt 49 76)(line_width 1))
 		(line (pt 50 52)(pt 50 76)(line_width 1))
 		(line (pt 49 92)(pt 49 116)(line_width 1))
@@ -74,9 +83,11 @@
 		(line (pt 110 52)(pt 110 76)(line_width 1))
 		(line (pt 111 92)(pt 111 116)(line_width 1))
 		(line (pt 110 92)(pt 110 116)(line_width 1))
+		(line (pt 111 132)(pt 111 156)(line_width 1))
+		(line (pt 110 132)(pt 110 156)(line_width 1))
 		(line (pt 0 0)(pt 160 0)(line_width 1))
-		(line (pt 160 0)(pt 160 144)(line_width 1))
-		(line (pt 0 144)(pt 160 144)(line_width 1))
-		(line (pt 0 0)(pt 0 144)(line_width 1))
+		(line (pt 160 0)(pt 160 184)(line_width 1))
+		(line (pt 0 184)(pt 160 184)(line_width 1))
+		(line (pt 0 0)(pt 0 184)(line_width 1))
 	)
 )
Index: sockit/pll_pal.cmp
===================================================================
--- sockit/pll_pal.cmp	(revision 310)
+++ sockit/pll_pal.cmp	(revision 311)
@@ -3,6 +3,7 @@
 			refclk   : in  std_logic := 'X'; -- clk
 			rst      : in  std_logic := 'X'; -- reset
 			outclk_0 : out std_logic;        -- clk
+			outclk_1 : out std_logic;        -- clk
 			locked   : out std_logic         -- export
 		);
 	end component pll_pal;
Index: sockit/pll_pal.ppf
===================================================================
--- sockit/pll_pal.ppf	(revision 310)
+++ sockit/pll_pal.ppf	(revision 311)
@@ -8,6 +8,7 @@
   <pin name="refclk" direction="input" scope="external" />
   <pin name="rst" direction="input" scope="external" />
   <pin name="outclk_0" direction="output" scope="external" />
+  <pin name="outclk_1" direction="output" scope="external" />
   <pin name="locked" direction="output" scope="external" />
  </global>
 </pinplan>
